%% Day 1 HW solutions for Learning Catalytics questions
% Written by BB 2018/08/07
clear
close all

%% Problem 1

% Make an array by directly entering it and store it in a variable named x.
x = [3 4 5; 2 1 2; 3 2 1; 2 3 1];

% What is the size of the array x? (Returns '4 3' so 4 rows, 3 columns)
size(x)


%% Problem 2

% Write a line of code using the size command that returns only the number 
% of rows the array x.

size(x,1)


%% Problem 3

% Write a line of code using the size command that returns only the number 
% of columns the array x.

size(x,2)

%% Problem 4

% Using the same array x as before, what will length(x) return?

length(x) %4

% Length returns the maximum size, i.e. 'max(size(x))'. It's useful for
% vectors, i.e. 1-dimensionsal arrays that have only one row or one column

%% Problem 5

% What will x = [x;3] do?
%
% This returns an error message: 
%
%   Error using vertcat
%   Dimensions of arrays being concatenated are not consistent. 
%
% This command attempts to place the number 3 into a new row. But this is
% ambiguous because we didn't specify which column. We could make this work
% by specifying the exact position
%
%   x(end+1,1) = 3;
%
% This would place the number 3 into a new row below the existing rows in
% the first column. 
%
% We could also make this work by concatenating an array with the same
% number of columns:
%
%   x = [x;[3 0 0]]

%% Problem 6

% Conceptually, what does this do:
% 
%   x(:,4) = x(:,2)
%
% This will replace the values in the 4th column of x with the values in
% the 2nd column. However, our array only has 3 columns. Therefore, it will
% concatenate a copy of the 2nd column on as a new column
%
% We could have also written this as
%
%   x = [x x(:,2)]
% 

%% Problem 7

% What will this return?
%
%   x([2,3,1],[2,1])
%

x([2,3,1],[2,1])
 
% This returns:
%  
%  ans =
% 
%      1     2
%      3     2
%      2     3
%
% The first argument [2,3,1] says to extract the 2nd, 3rd, and 1st rows,
% while [2,1] says to extract the 2nd and 1st columns. Since there are 3 
% rows and 2 columns being indexed, the answer will be a 3x2 array with the
% values:
%
%   x(2,2)  x(2,1)
%   x(3,2)  x(3,1)
%   x(1,2)  x(1,1)
%

%% Problem 8

% What will this return?
%

x([x(5), x(2,1)+1],mean([x(4,2),x(end)]))

% This returns a 2x1 array. If you didn't run the code from #6 adding the 
% fourth column, the answer is 
%
%   ans =
% 
%       3
%       2
%
% If you did run the command from #6, the answer is 
%
%   ans =
% 
%       1
%       1
%
% Let's break this down. The first argument [x(5), x(2,1)+1] is a 1x2
% array. The first element x(5) uses linear indexing to return the value 4 
% since x(5) is the same as x(1,2). Remember that linear indexing counts
% along the rows first before incrementing the columns.
%
% The second element x(2,1)+1 adds 1 to the value 2, so it return 3. This
% means this 1x2 array is actually [4,3] meaning the 4th and 3rd rows of x
%
% The second column uses the 'mean' function of another 1x2 array, 
% [x(4,2),x(end)]. The first element x(4,2) uses row-column indexing to
% return the value 3, while x(end) uses linear indexing to return the last
% element, i.e. the value 1. (If you ran the code from #6, this value is 3)
%
% The whole 2nd argument is therefore mean([3 1]), which returns the mean
% of this array, i.e. 2.
%
% Therefore, the simplified version is x([4,3],2). This means to extract
% the values in the 4th and 3rd rows of the 2nd column, so the array [3;2]


%% Problem 9
% 
% What will this return?
% 
%   x(end,end)

x(end,end)

% This returns the single number 1, since it is the value in the last
% column and last row of x. If you ran the code from #6, the answer would
% be 3

%% Problem 10

% What will this return?

start = 1;
step = 2;
stop = 100;
length(start:step:stop)

% This returns 50. The last line length(start:step:stop) takes the length
% of the array start:step:stop. This array uses the colon operator to
% create an array.
%
% The colon operator works by starting with 1 (the value of 'start') and
% then incrementing by 2 (the value of 'step) until it gets to 99 (the
% closest possible value less than 'stop'). In other words, the values are
%
%   1, 3, 5, ..., 95, 97, 99
%
% There are 50 values in this array, so the length function will return 50
%
%

%% Problem 11

% Start by typing t = (1:100)*pi/25;
% 
% Now do the following: Plot sin(t) on the y axis and t on the x axis.
% 
% Add to this plot (i.e. dont overwrite it) cos(t) on the y axis in red circles.
% 
% Now add tan(t) in green and make the LineWidth equal to 2.
% 
% Plot a green line going from the point (0,0) to the point (20,10).
% 
% Sketch the result here (doesn't worry about being very accurate in your drawing)

% Make t array 
t = (1:100)*pi/25;

% We make a new figure with the figure command. This is good practice since 
% it won't overwrite some plot that's already open
figure

% Plot sine
plot(t,sin(t),'b') 

% You don't really need the 'b' here since Matlab's first default color is
% already blue-ish, but since we are specifying the other colors, it's 
% good to be consistent. In some future release Matlab's default color
% might be different

% Use the 'hold on' to prevent new lines from overwriting previous ones.
% This only applies to the current figure. You'll have to type 'hold on'
% for each new figure
hold on 

% ------------ Begin unnecessary info about Matlab's history --------------
%
% In old versions of Matlab you had to type hold on after you had already
% plotted something, meaning once the figure had an "axes" object
%
% In other words, this would only show the (x2,y2) line since hold on
% didn't do anything if nothing had been plotted yet:
%
%   figure
%   hold on
%   plot(x1,y1)
%   plot(x1,y2)   
%
% But this would show both lines:
%
%   figure
%   plot(x1,y1)
%   hold on
%   plot(x1,y2) 
%
% In newer versions of matlab, the behavior is the same (yay!). You can try
% this out yourself by typing
%
%   figure   %<---creates a blank figure with no axes
%   hold on  %<---the figure now has a set of blank axes

% ------------- End unnecessary info about Matlab's history ---------------

% Plot cosine in red circles
plot(t,cos(t),'ro')

% Plot tangent
plot(t,tan(t),'g','LineWidth',2)

% Add green line. Note that we have to pair up the two x values and the 
% two y values in arrays. I also explicity added the 'g-' to
% specify a green line, but a line is the default so it's unnecessary. 
plot([0 20],[0 10],'g-')

% We could also use
%
%   line([0 20],[0 10],'Color','g')
%
% The difference between the line and plot command is that line will place
% a line regardless of whether 'hold' is on or off.


% There are many different LineStyles and Marker possibilities. Here's a
% fun one: Why is 
%
%   plot(x,y,'.-') 
%
% different than 
%
%   plot(x,y,'-.')
%

%% Problem 12

% For a full explanation of answers for problem 12-14, see  
% 'FlowCytometrySolution.m'. Below are just answers to the Learning
% Catalytics questions
%
%   
% How many red cells did you identify?
%
%   Depending on your threshold, it should be around 5200
%

%% Problem 13

% How many blue cells did you identify?
%
%   Depending on your threshold, it should be around 4800
%

%% Problem 14

% What is bigger, the YFP value of the RFP cells or the BFP cells?
%
%   The YFP value of the BFP cells is larger
%


